#define SUPPRESS_COMPILER_INLINES
#ifdef LATTICE
#include "/lpc_incl.h"
#include "/comm.h"
#include "/file_incl.h"
#include "/file.h"
#include "/backend.h"
#include "/swap.h"
#include "/compiler.h"
#include "/main.h"
#include "/eoperators.h"
#include "/simul_efun.h"
#include "/add_action.h"
#else
#include "../lpc_incl.h"
#include "../comm.h"
#include "../file_incl.h"
#include "../file.h"
#include "../backend.h"
#include "../swap.h"
#include "../compiler.h"
#include "../main.h"
#include "../eoperators.h"
#include "../efun_protos.h"
#include "../simul_efun.h"
#include "../add_action.h"
#endif

#include <sys/iconv.h>

#ifdef F_ICONV_STRING
void f_iconv_string PROT((void)) {
    char *encFrom,*encTo;
    const char *str;
    char bufout[max_string_length],*bfi,*bfo;
    size_t sin,sout;
    int i;
    iconv_t c_pt;
    
    encFrom = (sp-2)->u.string;
    encTo = (sp-1)->u.string;
    str = (sp)->u.string;
    
    if(st_num_arg < 3)
    	error(" Error!!! iconv_string(encFrom,encTo,string);");
	
    if ((c_pt = iconv_open(encTo, encFrom)) == (iconv_t)-1) {	
    	error(" Error!!! Just only \"Big5,GB2312,UTF8\"!!");
    }
    for(i=0;i<max_string_length;i++) bufout[i] = '\0';
    iconv(c_pt, NULL, NULL, NULL, NULL);

    bfo = bufout;
    sin = (int)(SVALUE_STRLEN(sp));
    sout = (int)(SVALUE_STRLEN(sp))+512;
    iconv(c_pt, &str, &sin ,&bfo, &sout);
    iconv_close(c_pt);
//    debug_message(" -> %s\n",bufout);

    pop_stack();  
    pop_stack();
    (sp)->type = T_STRING;
    (sp)->subtype = STRING_MALLOC;
    (sp)->u.string = bufout;
}
#endif
